﻿Imports C1.Win.C1Chart
Imports Salon_And_Spa_Studio_2019.SalonAndSpaDb2DataSet

Public Class FormChart
    Dim GroupedData As IEnumerable(Of IGrouping(Of Object, tblRoomOccupancyRow))
    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub
    Private Sub FormChart_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'SalonAndSpaDb2DataSet1.tblRoomOccupancy' table. You can move, or remove it, as needed.
        Me.TblRoomOccupancyTableAdapter.Fill(Me.SalonAndSpaDb2DataSet.tblRoomOccupancy)
        InitChart()
    End Sub
    Private Sub InitChart()
        Dim grp0 = C1ChartRoomOccupancy.ChartGroups.Group0
        grp0.ChartData.SeriesList.Clear()

        grp0.ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Gantt
        Dim Data = Me.SalonAndSpaDb2DataSet.tblRoomOccupancy 'GetData()
        GroupedData = Data.GroupBy(Function(row) New With {Key .RoomName = row.RoomName})
        For Each item In GroupedData
            Dim ser = grp0.ChartData.SeriesList.AddNewSeries()
            ser.Label = item.Key.RoomName
            Dim startTimes = item.Select(Of DateTime)(Function(row) row.StartTime).ToArray()
            Dim endTimes = item.Select(Of DateTime)(Function(row) row.EndTime).ToArray()
            ser.Y.CopyDataIn(startTimes)
            ser.Y1.CopyDataIn(endTimes)
        Next

        C1ChartRoomOccupancy.ChartArea.Inverted = True
        C1ChartRoomOccupancy.ChartArea.AxisX.Reversed = True

        Dim startDate = New DateTime(Data.First().StartTime.Year, Data.First().StartTime.Month, Data.First().StartTime.Day, 8, 0, 0)
        Dim endDate = New DateTime(Data.Last().EndTime.Year, Data.Last().EndTime.Month, Data.Last().EndTime.Day, 18, 0, 0)

        C1ChartRoomOccupancy.ChartArea.AxisY.Min = startDate.ToOADate()
        C1ChartRoomOccupancy.ChartArea.AxisY.Max = endDate.ToOADate()
        C1ChartRoomOccupancy.ChartArea.AxisY.AutoMinor = False
        '
        'Use the following for default Short Time labels: e.g :    8:00 9:00 10:00 etc.
        ''
        'C1ChartRoomOccupancy.ChartArea.AxisY.AnnoFormat = C1.Win.C1Chart.FormatEnum.DateShortTime
        'C1ChartRoomOccupancy.ChartArea.AxisY.UnitMajor = 0.05 'For 1 hour gap between labels

        ' ------------------------ Or -------------------------------------------------
        'Use the following for custom time labels: e.g :    8:00 AM  9:00 AM 10:00 AM etc.

        C1ChartRoomOccupancy.ChartArea.AxisY.AnnoMethod = C1.Win.C1Chart.AnnotationMethodEnum.ValueLabels
        Dim dt = startDate
        While dt <= endDate
            C1ChartRoomOccupancy.ChartArea.AxisY.ValueLabels.Add(dt.ToOADate(), dt.ToString("hh:00 tt"))
            dt = dt.AddHours(1)
        End While

        C1ChartRoomOccupancy.ChartArea.AxisY.GridMinor.Spacing = 1.0 / (24 * 60) * 15 '15 Minutes Increment
        C1ChartRoomOccupancy.ChartArea.AxisY.GridMajor.Color = Color.Black

        C1ChartRoomOccupancy.ToolTip.Enabled = True
        C1ChartRoomOccupancy.ToolTip.SelectAction = C1.Win.C1Chart.SelectActionEnum.MouseOver
        AddHandler C1ChartRoomOccupancy.ShowTooltip, AddressOf C1ChartRoomOccupancy_ShowTooltip
    End Sub

    Private Sub C1ChartRoomOccupancy_ShowTooltip(sender As Object, e As ShowTooltipEventArgs)
        If sender.GetType() = GetType(ChartDataSeries) Then
            Dim position = C1ChartRoomOccupancy.PointToClient(Control.MousePosition)
            Dim serIdx = 0, ptIdx = 0, dist = 0
            C1ChartRoomOccupancy.ChartGroups.Group0.CoordToDataIndex(position.X, position.Y, CoordinateFocusEnum.XandYCoord, serIdx, ptIdx, dist)
            Dim item = GroupedData.ElementAt(serIdx).ElementAt(ptIdx)
            e.TooltipText = "Room:" & item.RoomName & vbCrLf & "Client ID:" & item.ClientID & vbCrLf & "User ID: " & item.UserID & vbCrLf & "From: " & item.StartTime.ToString("hh:mm tt") & " - To: " & item.EndTime.ToString("hh:mm tt")
        End If
    End Sub
    'Private Function GetData() As List(Of DataItem)
    '    Dim Data = New List(Of DataItem)
    '    Dim baseTime = New DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, 8, 0, 0)
    '    Data.Add(New DataItem With {.Task = "Task 1", .StartTime = baseTime, .EndTime = baseTime.AddHours(1)})
    '    Data.Add(New DataItem With {.Task = "Task 2", .StartTime = baseTime.AddMinutes(45), .EndTime = baseTime.AddHours(2)})
    '    Data.Add(New DataItem With {.Task = "Task 3", .StartTime = baseTime.AddHours(2), .EndTime = baseTime.AddHours(3)})
    '    Data.Add(New DataItem With {.Task = "Task 4", .StartTime = baseTime.AddMinutes(2 * 60 + 30), .EndTime = baseTime.AddHours(6)})
    '    Data.Add(New DataItem With {.Task = "Task 5", .StartTime = baseTime.AddHours(4), .EndTime = baseTime.AddHours(6)})
    '    Data.Add(New DataItem With {.Task = "Task 6", .StartTime = baseTime.AddHours(7), .EndTime = baseTime.AddHours(8)})
    '    Return Data
    'End Function
End Class
Public Class DataItem
    Public Property Task As String
    Public Property StartTime As DateTime
    Public Property EndTime As DateTime
End Class